<template lang="pug">
  v-container(fluid='')
    v-row
      v-col.mx-2(cols="3" v-for="document of documents" )
        Document(v-bind="document")
    v-row
      v-col(align="right")
        v-dialog(transition='dialog-bottom-transition' v-model="dialog")
          template(v-slot:activator='{ on, attrs }')
            v-btn(text='' right='' outlined='' color='teal accent-4' @click='reveal = true' v-on='on')
              | Добавить
          template(v-slot:default='dialog')
            v-card
              v-toolbar(color='primary' dark='') Добавление документа
              v-card-text
                v-container
                  v-form
                    v-row
                      v-col(cols="5")
                        v-select(v-model='newDocument.type' :items="documentTypes" label='Тип' required='')
                      v-col(cols="5")
                        v-text-field(v-model='newDocument.number' label='Номер' required='')
                    v-row(v-for="")
                      v-col(cols="2")
                        p Дополнительные поля
                      v-col(cols="2")
                        v-btn(@click="AddField()") Добавить
                    v-row
                      v-col(cols="2" v-for="(field, i) of extNames")
                        v-text-field(label="Название" v-model="extNames[i]")
                        v-text-field(label="Значение" v-model="newDocument.extFields[extNames[i]]")
                    v-row(v-if="newDocument.type === typesDict.productType")
                      v-col
                        v-row
                          v-col
                            p Поставщик:
                        v-row
                          v-col
                            v-select(v-model="selectProvider" key="id" return-object='' item-text="name" :items="providers" @change="SelectProvider()")
                          v-col(cols="1")
                            v-text-field(v-model='newDocument.provider.id' label='№' required='' disabled='')
                          v-col(cols="3")
                            v-text-field(v-model='newDocument.provider.name' label='Имя' required='' disabled='')
                        v-row
                          v-col
                            v-text-field(v-model='newDocument.provider.addr' label='Юр. Адрес' required='' disabled='')
                          v-col
                            v-text-field(v-model='newDocument.provider.inn' label='ИНН' required='' disabled='')
                        v-row
                          v-row
                            v-col
                              p Товары:
                              v-row
                                v-col
                                  v-btn(@click="AddItem") Добавить
                              v-row
                                  div(v-for="(item, i) of newDocument.items")
                                    v-col
                                      v-select(v-model="newDocument.items[i]" :items="products" item-text="name" return-object="")
                                    v-col
                                      v-text-field(v-model='newDocument.items[i].id' label='№' required='' disabled='')
                                    v-col
                                      v-text-field(v-model='newDocument.items[i].name' label='Название' required='' disabled='')
                                      v-text-field(v-model.number='newDocument.items[i].price' label='Цена' required='' @change="itemSum(i)" )
                                      v-text-field(v-model.number='newDocument.items[i].count' label='Количество' required='' @change="itemSum(i)")
                                      v-text-field(v-model.number='newDocument.items[i].sum' label='Сумма' required='' disabled='' )
                        v-row
                          v-col
                            p Сумма: {{allSum}}
              v-card-actions.justify-end
                v-btn(text='' @click='Add') Добавить
                v-btn(text='' @click='dialog.value = false') Закрыть
</template>

<script>
  import Document from '../components/Document'
  const typeProduct = 'Товарная накладная'
  const emptyItem = {id: '', name: '', price: 0, count: 0, sum: 0, extFields: {}}
  export default {
    name: 'Home',
    mounted() {
      this.$store.dispatch("getSession")
      this.$store.dispatch("getList")
      this.$store.dispatch("getListProviders")
      this.$store.dispatch("getListProducts")
    },
    computed: {
      providers () {
        return this.$store.getters.providers
      },
      documents () {
        return this.$store.getters.documents
      },
      products () {
        return this.$store.getters.products
      },
      allSum() {
        let sum = 0
        for (const item of this.newDocument.items) {
          sum += item.sum
        }
        return sum
      }
    },
    watch: {

    },
    components: {
      Document,
    },
    methods: {
      Add() {
        this.$store.dispatch('add', this.newDocument).then(() => {
          this.newDocument = {id: '', name: '', price: 0, count: 0, sum: 0, extFields: {}}
          this.dialog = false
        })
      },
      SelectProvider() {
        this.newDocument.provider = this.selectProvider
      },
      AddItem() {
        this.newDocument.items.push({id: '', name: '', price: 0, count: 0, sum: 0, extFields: {}})
      },
      AddField() {
        this.extNames.push('')
      },
      itemSum(i) {
        const item = this.newDocument.items[i];
        if (!item) return 0;
        item.sum = item.price*item.count
        this.newDocument.items[i] = item
      }
    },
    data: () => ({
      reveal: false,
      emptyItem: emptyItem,
      typesDict: {
        productType: typeProduct,
      },
      documentTypes: [typeProduct],
      selectProvider: {},
      dialog: false,
      extNames: [],
      newDocument: {
        type: '',
        owner: '',
        number: '',
        provider: {
          id: '',
          name: '',
          addr: '',
          inn: ''
        },
        extFields: {},
        items: [
          emptyItem,
        ]
      }
    })
  }
</script>
